{{
  PFunk ("P-Funk") - PASM Functionalizer

  Jonathan "lonesock" Dummer
}}

CON PAR_address = 16

VAR
  long PASM_ptr, PAR_ptr
  byte cog
  
PUB start
  stop
  PASM_ptr~~
  cog := cognew( @PASM_Func, @PASM_ptr ) + 1
  repeat while PASM_ptr

PUB stop
  if cog
    cogstop( cog~ - 1 )

PUB run( PASM_address, PAR_value )
  PAR_ptr := PAR_value
  PASM_ptr := PASM_address
  repeat while PASM_ptr

DAT
ORG 0
PASM_Func               ' clear the PASM pointer (signifies the function is done)
                        mov     fptr, #0
                        wrlong  fptr, par
:waiting                ' wait till we get a function to run
                        rdlong  fptr, par wz
              if_z      jmp     #:waiting
                        ' got something, the 1st long holds the length of the PASM routine
                        movd    :load_func, #PAR_address + 1                       
                        rdlong  pptr, fptr
                        ' load in the function
:load_loop              add     fptr, #4
:load_func              rdlong  0-0, fptr                         
                        add     :load_func, one_dest
                        djnz    pptr, #:load_loop
                        ' load the fake PAR register
                        mov     pptr, par
                        add     pptr, #4
                        rdlong  pptr, pptr
                        ' run the function
                        jmp     #PAR_address + 1  

' internal variables for my function load/run-er                     
one_dest      long      512
fptr          res       1

' the faux-par register will be the 1st long
FIT PAR_address
pptr          res       1
' here is where the function will load                                